local function SetValueCallback(key, isTrue)
end

local function InvalidValueCallback(expectingNumber)
end

local function GetValueCallback(key, callbackValue)
end

--Testing Suite

local function doMainTest()

    -- SetValue
    osrs.Persistence:setValue("TestValid", "Example Value", SetValueCallback) 
    osrs.Persistence:setValue("TestLongValue", "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce vel ex dolor. Sed non lorem a eros egestas placerat in quis lorem. Duis posuere elit ac orci lobortis fringilla. Fusce sed nulla lobortis metus cursus rutrum. Vestibulum vitae nisi mi. Vestibulum lectus nibh, tristique at aliquet id, tincidunt non magna. Proin porttitor molestie dignissim. In hac habitasse platea dictumst. Proin ullamcorper lacus metus, vel accumsan elit efficitur eu. Morbi ut orci laoreet lectus interdum ultrices. Aenean ac convallis erat. Quisque pretium nisl vitae vulputate convallis. Quisque ante mi, auctor tincidunt est sed, maximus consequat lectus. Cras lacinia sed erat in sollicitudin. ", SetValueCallback)
    osrs.Persistence:setValue("Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce vel ex dolor. Sed non lorem a eros egestas placerat in quis lorem. Duis posuere elit ac orci lobortis fringilla. Fusce sed nulla lobortis metus cursus rutrum. Vestibulum vitae nisi mi. Vestibulum lectus nibh, tristique at aliquet id, tincidunt non magna. Proin porttitor molestie dignissim. In hac habitasse platea dictumst. Proin ullamcorper lacus metus, vel accumsan elit efficitur eu. Morbi ut orci laoreet lectus interdum ultrices. Aenean ac convallis erat. Quisque pretium nisl vitae vulputate convallis. Quisque ante mi, auctor tincidunt est sed, maximus consequat lectus. Cras lacinia sed erat in sollicitudin. ","TestLongKey", SetValueCallback)
    osrs.Persistence:setValue("TestIntegerValue", "2020", SetValueCallback)
    osrs.Persistence:setValue("2020", "TestIntegerKey", SetValueCallback)
    osrs.Persistence:setValue("TestFloatValue", "20.23", SetValueCallback)
    osrs.Persistence:setValue( "20.23", "TestFloatKey", SetValueCallback)
    osrs.Persistence:setValue("TestInvalidFunction", "Placeholder Value", SetValueCallback) 
    osrs.Persistence:setValue("Test567", "Test567--value") -- make sure no crashes if callback omitted.

    -- GetValue
    osrs.Persistence:getValue("TestValid", GetValueCallback)
    osrs.Persistence:getValue("TestLongValue", GetValueCallback)
    osrs.Persistence:getValue("Lorem ipsum dolor sit amet, consectetur adipiscing elit. Fusce vel ex dolor. Sed non lorem a eros egestas placerat in quis lorem. Duis posuere elit ac orci lobortis fringilla. Fusce sed nulla lobortis metus cursus rutrum. Vestibulum vitae nisi mi. Vestibulum lectus nibh, tristique at aliquet id, tincidunt non magna. Proin porttitor molestie dignissim. In hac habitasse platea dictumst. Proin ullamcorper lacus metus, vel accumsan elit efficitur eu. Morbi ut orci laoreet lectus interdum ultrices. Aenean ac convallis erat. Quisque pretium nisl vitae vulputate convallis. Quisque ante mi, auctor tincidunt est sed, maximus consequat lectus. Cras lacinia sed erat in sollicitudin. ", GetValueCallback)
    osrs.Persistence:getValue("TestNotAKey", GetValueCallback)
    osrs.Persistence:getValue("TestIntegerValue", GetValueCallback)
    osrs.Persistence:getValue("TestFloatValue", GetValueCallback)
    osrs.Persistence:getValue("2020", GetValueCallback)
    osrs.Persistence:getValue("20.23", GetValueCallback)
    osrs.Persistence:getValue("TestValid", GetValueCallback)

    -- Delete and read key. 
    osrs.Persistence:setValue("TestValid", nil, function() 
        osrs.Persistence:getValue("TestValid", function(key,value) 
            osrs.print(string.format("TestValid value correctly unset? %s", tostring(value==nil)))
        end)
    end)

end

osrs.print("Starting Persistence Test...")
doMainTest();